/* pdflua.c

   Copyright 2010 Taco Hoekwater <taco@luatex.org>
   Copyright 2010 Hartmut Henkel <hartmut@luatex.org>

   This file is part of LuaTeX.

   LuaTeX is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   LuaTeX is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
   License for more details.

   You should have received a copy of the GNU General Public License along
   with LuaTeX; if not, see <http://www.gnu.org/licenses/>. */

#include "ptexlib.h"

static const Byte compr[259] = {
    0x78, 0x9c, 0xad, 0x51, 0xc1, 0x4a, 0xc4, 0x30, 0x10, 0xbd, 0xe7, 0x2b, 0xe6, 0xd0, 0x83, 0xc2,
    0x36, 0x49, 0x57, 0x59, 0x69, 0xc1, 0x0f, 0x10, 0x3c, 0x09, 0x5e, 0xbc, 0xa5, 0xe9, 0xb4, 0x0d,
    0x0d, 0x49, 0x98, 0x24, 0xae, 0x8b, 0xf8, 0xef, 0xa6, 0x50, 0x74, 0x55, 0xbc, 0x6d, 0x98, 0x84,
    0xc7, 0xbc, 0x97, 0x79, 0x0f, 0xa6, 0xae, 0xa1, 0x7a, 0x18, 0x3a, 0x08, 0xc3, 0x68, 0xb3, 0xe2,
    0xe5, 0xc2, 0x4d, 0x7b, 0xdb, 0xc2, 0x5e, 0x36, 0xb2, 0x6e, 0x9a, 0x5a, 0xde, 0x81, 0x94, 0x9d,
    0x6c, 0xbb, 0xa6, 0x7d, 0x81, 0x79, 0x46, 0xb7, 0xa0, 0x85, 0x8a, 0xd5, 0xe5, 0xdb, 0xf3, 0xd3,
    0x63, 0x07, 0x73, 0x4a, 0xa1, 0x13, 0x62, 0xf4, 0xd9, 0x0d, 0x74, 0xe2, 0x31, 0x07, 0xb4, 0xa8,
    0xf9, 0x48, 0x22, 0xbe, 0x3a, 0x51, 0xc6, 0x25, 0x7c, 0x13, 0x49, 0x4d, 0x51, 0xf4, 0x98, 0x54,
    0x2d, 0xf9, 0xe1, 0xc0, 0xa5, 0x88, 0x3e, 0x93, 0x46, 0x51, 0xb8, 0x45, 0x1c, 0xb1, 0xdf, 0xeb,
    0x4d, 0x39, 0x18, 0x5a, 0x51, 0xd4, 0x64, 0x42, 0x8a, 0xe2, 0x2c, 0x54, 0xc5, 0x56, 0xcf, 0x34,
    0x9b, 0x08, 0xa5, 0x50, 0x91, 0x3d, 0xc1, 0xd1, 0xd3, 0x02, 0xc6, 0x41, 0x20, 0x3f, 0x11, 0xc6,
    0xc8, 0x39, 0x5f, 0x55, 0x97, 0x39, 0x8c, 0xf5, 0x38, 0x19, 0x17, 0xd4, 0x84, 0x70, 0x0f, 0x63,
    0x76, 0x3a, 0x19, 0xef, 0xae, 0xd4, 0x35, 0x43, 0x37, 0xb0, 0xf5, 0xf9, 0x8f, 0xf2, 0x39, 0x85,
    0x52, 0x85, 0x8d, 0x89, 0xf0, 0x87, 0x64, 0x53, 0x5c, 0x2e, 0xa3, 0xf5, 0x5a, 0xd9, 0x6d, 0x79,
    0xc5, 0xe8, 0x9d, 0x01, 0x9c, 0xc7, 0xfe, 0xc2, 0xbb, 0x42, 0x7c, 0x47, 0xde, 0xd0, 0xda, 0xfc,
    0x1b, 0xf6, 0x57, 0x67, 0xc7, 0x3e, 0x18, 0x23, 0x4c, 0x99, 0xdc, 0xe6, 0xc3, 0x3e, 0x01, 0x6c,
    0x2e, 0xa2, 0xa9
};

static const zlib_struct compr_struct = { 564, 259, compr };

const zlib_struct *pdflua_zlib_struct_ptr = &compr_struct;
